#include <Wire.h>
#include <AD770X.h>
#include <LiquidCrystal_I2C.h>
#include <string.h>
#include <TimerOne.h> 
volatile uint8_t tic ; 
uint8_t data; 
//#include <CyberLib.h> 
AD770X ad7706(2.5);
double R1, R2; 
LiquidCrystal_I2C lcd(0x27, 16, 2);
byte buzzerPin = 4;
int startDimPin = 5; //первый диммер 
int endDimPin = 6; //последний диммер 
int Dimmer[3]; //количество диммеров минус 1
#define DRDY 9            
#define EnableTop 7    
#define EnableBottom 3 
byte LevelTop = 0x00;  
byte LevelBottom = 0x00; 
double Temp_Top = 0;     
double Temp_Bottom = 0;  
int Temp1, Temp2, Temp11, Temp12;
byte EnableLed = 0xFF;   
char command_in[6];      
const byte DESIRED_WIDTH = 3;

void setup() {
    Serial.begin(14400);
   for ( int i = startDimPin; i <= endDimPin; i++) //пройдемся циклом по портам 
  { 
    pinMode (i, OUTPUT); 
    digitalWrite(i, LOW); // гасим оответствующий пин 

    Dimmer[i - startDimPin] = 0; //выставим яркость соответствующего диммера в 0 
  } 
  attachInterrupt(0, detect_up, LOW);
  Timer1.initialize(40); 
   Timer1.attachInterrupt(halfcycle); 
    Timer1.stop(); 
  lcd.begin();
  lcd.clear();
  lcd.backlight();
  lcd.setCursor(1, 0);
  lcd.print("SOLDER STATION");
  lcd.setCursor(5, 1);
  lcd.print("v2.1.2");
  tone(buzzerPin, 523);
  delay(200);
  tone(buzzerPin, 659);
  delay(200);
  tone(buzzerPin, 784);
  delay(200);
  noTone(buzzerPin);
  delay(3000);
  lcd.clear();
  pinMode(EnableTop, OUTPUT);
  pinMode(EnableBottom, OUTPUT);
  digitalWrite(EnableTop, LOW);
  digitalWrite(EnableBottom, LOW);

}
String addZeroes(const String& src, byte pad)
{
  if (src.length() >= pad)
    return src;
  String result;
  byte add = pad - src.length();
  while (add--)
    result += "0";
  result += src;
  return result;
}
void halfcycle()  //прерывания таймера 
{ 
  tic--;  //счетчик 
  for ( int i = startDimPin; i <= endDimPin; i++) 
  { 
    if (Dimmer[i - startDimPin] > tic ) 
      digitalWrite(i, HIGH); //управляем выходом (откроем семистор) 
  } 
} 

void  detect_up()  // обработка внешнего прерывания. Сработает по переднему фронту 
{ 
  tic = 200;           //обнулить счетчик 
  Timer1.resume();   //запустить таймер 
  attachInterrupt(0, detect_down, HIGH);  //перепрограммировать прерывание на другой обработчик 
} 

void  detect_down()  // обработка внешнего прерывания. Сработает по заднему фронту 
{ 
  Timer1.stop(); //остановить таймер 
  for ( int i = startDimPin; i <= endDimPin; i++) 
  { 

    digitalWrite(i, LOW); 
  } 
  tic = 200;     //обнулить счетчик 
  attachInterrupt(0, detect_up, LOW); //перепрограммировать прерывание на другой обработчик 

} 

void loop() {
  while ( !digitalRead(DRDY) );
  R1 = ad7706.readADResult(AD770X::CHN_AIN1);
  double Temp_Bottom = (R1 - 1) / 0.00492;
  delay(20);
  R2 = ad7706.readADResult(AD770X::CHN_AIN2);
  double Temp_Top = (R2 - 1) / 0.00492;
  int i = 0;
  int buffer[6];
  if (Serial.available()) {
     delay(100);
    while ( Serial.available() && i < 7) {
      buffer[i++] = Serial.read();
    }
    buffer[i++] = '\0';
  }
  if (i > 0) { 
    if (buffer[0] == 0xAA) { 
      LevelTop = buffer[1];
      LevelBottom = buffer[2];
      EnableLed = buffer[3];
    } 
    Temp1 = int(Temp_Top); 
    Temp11 = 0;
    if (Temp1 > 255) {
      Temp11 = Temp1 - 255;
      Temp1 = 255;
    }
    Temp2 = int(Temp_Bottom); 
    Temp12 = 0;
    if (Temp2 > 255) {
      Temp12 = Temp2 - 255;
      Temp2 = 255;
    }
    Serial.write(170);
    Serial.write(Temp1);
    Serial.write(Temp11);
    Serial.write(Temp2);
    Serial.write(Temp12);
    Serial.write(255);
  }
  if (LevelTop == 0x00) {
    digitalWrite(EnableTop, LOW);
  }
  if (LevelTop != 0x00) {
    digitalWrite(EnableTop, HIGH);
  }
  if (LevelBottom == 0x00) {
    digitalWrite(EnableBottom, LOW);
  }
  if (LevelBottom != 0x00) {
    digitalWrite(EnableBottom, HIGH);
  }
  Dimmer[1] = LevelTop;
  Dimmer[0] = LevelBottom; 
  lcd.setCursor(1, 0);
  lcd.print("TH:");
  lcd.setCursor(1, 1);
  lcd.print("BH:");
  lcd.setCursor(8, 0);
  lcd.print("PWR:");
  lcd.setCursor(8, 1);
  lcd.print("PWR:");
  lcd.setCursor(4, 0);
  lcd.print(addZeroes(String(int(Temp_Top)), DESIRED_WIDTH));
  lcd.setCursor(4, 1);
  lcd.print(addZeroes(String(int(Temp_Bottom)), DESIRED_WIDTH));
  lcd.setCursor(12, 0);
  lcd.print(addZeroes(String(int(LevelTop)), DESIRED_WIDTH));
  lcd.setCursor(12, 1);
  lcd.print(addZeroes(String(int(LevelBottom)), DESIRED_WIDTH));
  if (EnableLed == 0x00) {
    lcd.noBacklight();
  }
  if (EnableLed == 0xFF) {
    lcd.backlight();
  }
}
